execline
Software
skarnet.org

# The `forstdin` program

`forstdin` uses its input as loop elements to run another program.

## Interface

In an execlineb script:

         forstdin [ -E | -e ] [ -p | -o okcodes | -x breakcodes ] [ -N | -n ] [ -C | -c ] [ -0 | -d delim ] variable loop...

- `forstdin` reads its standard input as it becomes available, splitting it on every line automatically.
- For every argument x in the split output, `forstdin` runs loop... as a child process, with variable=x added to its environment.
- `forstdin` then exits 0 if it has read something on stdin, and 1 if it hasn't read anything.

## Options

- `-p` : parallel mode. Do not wait for a loop... instance to finish before spawning the next one. forstdin will still wait for all instances of loop to terminate before exiting, though.
- `-o` okcodes : okcodes must be a comma-separated list of exit codes. If the `-p` flag hasn't been given and loop exits with one of the codes in okcodes, forstdin will run the following instances of the loop, but if the exit code is not listed in okcodes, forstdin will exit immediately with an approximation of the same exit code.
- `-x` breakcodes : like the previous option, but with inverted meaning - the listed exit codes are codes that will make forstdin break the loop and exit, and the unlisted exit codes will make it keep looping.
- `-e` : no autoimport. This is the default.
- `-E` : autoimport. Instead of spawning loop..., spawn `importas -ui variable variable loop...`. This substitutes variable into the command line instead of putting it into the environment.

Other options are similar (in name and functionality) to the switches passed to control a substitution mechanism, on purpose; however, `forstdin` does not call the substitution mechanism and has its own semantics for those options.

- `-N` : store the whole line in variable, including the terminating newline (or other delimiter).
- `-n` : chomp a terminating delimiter from the line from stdin before storing it into variable. This is the default. Note that if chomping is active, and the last line of stdin is not terminated by a delimiter, then this last line will not be processed.
- `-C` : crunch. If there is an empty line (i.e. that only contains a delimiter), do not call loop.
- `-c` : do not crunch, call loop even if the line is empty. This is the default.
- `-0` : accept null characters on its stdin, using them as delimiters. If this option and a `-d` option are used simultaneously, the rightmost one wins.
- `-d delim` : use the characters in string delim as delimiters for a line. Default is "`\n`", meaning the input is only split on newlines.

## Notes

- You can start loop... with `importas -u variable variable` to perform variable substitution.